# Attributes

| Attribute         | Data Type | Definition                                                                                                                                                                                        |
| ----------------- | --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| name              | String    | Name of the hierarchy. If this is not specified, the hierarchy has the same name as its dimension                                                                                                 |
| hasAll            | Boolean   | Whether this hierarchy has an 'all' member                                                                                                                                                        |
| allMemberName     | String    | Name of the all member. If this attribute is not specified, the all member is namedAll hierarchyName, for example, `All Store`.                                                                   |
| allMemberCaption  | String    | A string being displayed instead as the all member's name. Can be localized from Properties file using **#{propertyname}**.                                                                       |
| allLevelName      | String    | Name of the all level. If this attribute is not specified, the all member is named (All). Can be localized from Properties file using **#{propertyname}**.                                        |
| primaryKey        | String    | The name of the column which identifies members, and which is referenced by rows in the fact table. If not specified, the key of the lowest level is used. See also **CubeDimension.foreignKey**. |
| primaryKeyTable   | String    | The name of the table which contains **primaryKey**. If the hierarchy has only one table, defaults to that; it is required.                                                                       |
| defaultMember     | String    |                                                                                                                                                                                                   |
| memberReaderClass | String    | Name of the custom member reader class. Must implement the **mondrian.olap.MemberReader** interface.                                                                                              |
| caption           | String    | A string to be displayed in the user interface. If not specified, the hierarchy's name is used. Can be localized from Properties file using **#{propertyname}**.                                  |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pentaho.com/install/10.2-install/multidimensional-data-modeling-in-pentaho/about-multidimensional-expression-language/mondrian-schema-element-reference/hierarchy/attributes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
